
## Development 🏗️

Compilation can become difficult when using multiple languages on multiple operating systems. [Makefiles](https://www.gnu.org/software/make/manual/html_node/Introduction.html) are 🔑

In general commands denoted with `ci` should encompass all required action(s), while others should perform a single action.

### Compilation 👷

For compiliation, see [Makefile](Makefile) for library configuration.

From the root of the project:
```bash
make build
```

To package only the source-code, see [Makefile](Makefile)

From the root:
```bash
make dist
```

### Unit Testing 🧪

For C++, we have integrated [GoogleTest](https://github.com/google/googletest) as our testing framework.

From the root of the project:
```bash
make ctest
```

For Dart, the [SDK](https://dart.dev/tools/sdk) comes out-of-the-box with a comprehensive testing framework.

From the root of the projct:
```bash
make dtest
```

## Deployment 🚀

Currently configured to be manually deployed via:
```bash
dart pub publish
```

[Automated](https://dart.dev/tools/pub/automated-publishing) publishing.

```bash
git tag v1.2.3
git push origin v1.2.3
```

This will [publish](https://github.com/jeffmur/fhel/actions/workflows/publish.yml) via Github Actions.
